program integral
    use ISO_FORTRAN_ENV
    implicit none
    integer, parameter :: sp = REAL32
    integer, parameter :: dp = REAL64

    real(dp), parameter :: M_PI = 3.141592653589793238_dp
    real(dp), parameter :: dx_ub = 2._dp * M_PI
    real(dp), parameter :: dx_lb = 0._dp

    integer j, i, N
    real(dp) sum, step, dx

    real(dp) start, finish

    print '(A)', "+- Interior Points -+-- Computed Value -+"
    call timeBySeconds(start, 0._dp)

    do j=2, 29
        N = 2**j
        step = (dx_ub - dx_lb) / N

        sum = 0._dp

        sum = sum + abs(sin(dx_lb)) * step / 2._dp
        do i=1, N-1
            dx = i * step
            sum = sum + abs(sin(dx)) * step
        end do
        sum = sum + abs(sin(dx_ub)) * step / 2._dp

        print '(A, I10, A, E14.6, A)', "|     ", N, "    |   ", sum, "  |"
        print '(A)', "+-------------------+-------------------+"
    end do

    call timeBySeconds(finish, start)
    print '(/, A, F8.3, A)', "    Elapsed time: ", finish, " [seconds]"

!end program
contains
    subroutine timeBySeconds(currTime, prevTime)
        implicit none
        real(dp) currTime, prevTime
        integer(int64) clock, rate, count_max

        call system_clock(clock, rate, count_max)
        currTime = real(clock, dp) / real(rate, dp) - prevTime
    end subroutine
end
